# Extension Manager addenda file, version 0.0
# FILE: addenda.tcl
#
# The conventional method for adding locally developed Tcl commands to 
# this extension:
#
# 1. Edit the file ./pkgIndex.tcl .  Add the option '-develop 1'
#    to the call to 'em_extension new'.  This causes the extension
#    to be defined in 'development mode,' a mode which includes
#    commands listed in this addenda file as well as those listed in the
#    official contents file.
#
# 2. Create a file in this directory which defines the new command
#    when sourced.  By convention, the name of the new file should be 
#    the same as the base name of the public command it defines, with 
#    a '.tcl' file extension.
#
# 3. Following the header of this file is a single Tcl command,
#    '[em_extension lookup <...>] contents <list>' where <list> is a 
#    list of files.  Add the name of the file created in step 2 to this 
#    list.
#
# 4. Repeat steps 2 and 3 for each new command to add to this extension.
#

[em_extension lookup [file join [pwd] [string trimright [file dirname [info script]] ./]]] contents {
}
