/* FILE: oommfport.h               -*-Mode: c++-*-
 *
 * Machine specific #define's and typedef's, generated by oommfport.tcl
 *
 */

#ifndef OOMMFPORT_H
#define OOMMFPORT_H

/* End includes */     /* Optional directive to build.tcl */

/* Include and defines files that *may* be system dependent. */
#include <stdlib.h>
#include <string.h>
#include <tcl.h>
#define MEMBLOCKSIZE 4096 /* Natural system memory blocksize.  Shouldn't  */
               /* affect program correctness, but may affect performance. */


/* Define the Tcl release level and serial if missing from tcl.h */
#ifndef TCL_RELEASE_LEVEL
#define TCL_RELEASE_LEVEL 2
#endif
#ifndef TCL_RELEASE_SERIAL
#define TCL_RELEASE_SERIAL 2
#endif
#ifndef TCL_PATCH_LEVEL
#define TCL_PATCH_LEVEL	   "8.0p2"
#endif

/* Check that the version of Tcl used to produce this file    */
/* agrees with the version number from tcl.h at compile time. */
/* Remove this check at your own risk!!!                      */
#if (TCL_MAJOR_VERSION  != 8) || \
    (TCL_MINOR_VERSION  != 0) || \
    (TCL_RELEASE_LEVEL  != 2) || \
    (TCL_RELEASE_SERIAL != 2)
#error tclsh (8.0.2.2) and tcl.h versions differ
#endif


/* The filename of the Tcl shell of the OOMMF project.         */
/* It is used to interpret Tcl scripts in sub-processess.      */
#define OMF_SHELL "omfsh.exe"


/* The portion of the search path for the OOMMF project's Tcl  */
/* shell which is determined at configure/build time.          */
#define OMF_SHELL_STATIC_SEARCH_PATH "/oommf/bin C:/users/dgp/OOMMF/oommf/bin"

/* Variable type declarations.  The '****#m' */
/* types are at *least* '#' bytes wide.      */
typedef  int                 BOOL;
typedef  unsigned char       BYTE;
typedef  char                CHAR;
typedef  signed char        SCHAR;
typedef  unsigned char      UCHAR;
typedef  float              REAL4;
typedef  double             REAL8;
typedef  float              REAL4m;
typedef  double             REAL8m;
typedef  short               INT2;
typedef  unsigned short     UINT2;
typedef  int                 INT4;
typedef  unsigned int       UINT4;
typedef  int                 INT2m;
typedef  unsigned int       UINT2m;
typedef  int                 INT4m;
typedef  unsigned int       UINT4m;

#define POINTERWIDTH 4
#define BYTEORDER 4321

/* System type info */
#define UNIX 1
#define WINDOWS 2
#define MACINTOSH 3
#define SYSTEM_TYPE WINDOWS

/* Random number generator. Replace with your own if */
/* if you don't like rand().                        */
#define OMF_SRANDOM(seed)  srand(seed)
#define OMF_RANDOM()       rand()
#define OMF_RANDOM_MAX     RAND_MAX


/* For Windows */
#define rint(x) ((x)>=0 ? double(int(x+0.5)) : double(int(x-0.5)))

/* A few definitions taken from Windows' include files */
/* Certainly it's overkill */

#ifdef __cplusplus
extern "C" {
#endif

/* from windef.h */
#ifndef CONST
#define CONST const
#endif

/* from winnt.h */
#if (defined(_M_MRX000) || defined(_M_IX86) || defined(_M_ALPHA) || defined(_M_PPC)) && !defined(MIDL_PASS)
#define DECLSPEC_IMPORT __declspec(dllimport)
#else
#define DECLSPEC_IMPORT
#endif

typedef void *PVOID;
typedef wchar_t WCHAR;
typedef WCHAR *LPCWSTR;
typedef CHAR *LPSTR;
typedef CONST CHAR *LPCSTR;

#ifdef STRICT
#define DECLARE_HANDLE(name)  struct name##__ { int unused; };  typedef struct name##__ *name
#else  /* STRICT */
typedef PVOID HANDLE;
#define DECLARE_HANDLE(name)  typedef HANDLE name
#endif /* !STRICT */

/* from windef.h */
#undef far
#undef near

#define far
#define near
#if (_MSC_VER >= 800) || defined(_STDCALL_SUPPORTED)
#define WINAPI __stdcall
#define APIENTRY WINAPI
#else
#define WINAPI
#define APIENTRY WINAPI
#endif

#define FAR far
#define NEAR near

typedef unsigned int UINT;

#ifndef WIN_INTERNAL
DECLARE_HANDLE (HWND);
#endif
DECLARE_HANDLE(HINSTANCE);

/* from winuser.h */
#if !defined(_USER32_)
#define WINUSERAPI DECLSPEC_IMPORT
#else
#define WINUSERAPI
#endif

/* Message Box Support (partial) */
#define MB_OK                       0x00000000L
#define MB_ICONHAND                 0x00000010L
#define MB_ICONEXCLAMATION          0x00000030L
#define MB_ICONSTOP                 MB_ICONHAND
#define MB_TASKMODAL                0x00002000L
#define MB_SETFOREGROUND            0x00010000L

#ifndef UNICODE_ONLY
WINUSERAPI
int
WINAPI
MessageBoxA(
    HWND hWnd ,
    LPCSTR lpText,
    LPCSTR lpCaption,
    UINT uType);
#endif //!UNICODE_ONLY
#ifndef ANSI_ONLY
WINUSERAPI
int
WINAPI
MessageBoxW(
    HWND hWnd ,
    LPCWSTR lpText,
    LPCWSTR lpCaption,
    UINT uType);
#endif //!ANSI_ONLY
#ifdef UNICODE
#define MessageBox  MessageBoxW
#else
#define MessageBox  MessageBoxA
#endif // !UNICODE
WINUSERAPI
BOOL
WINAPI MessageBeep(UINT uType);
void WINAPI ExitProcess(UINT);

#ifdef __cplusplus
} // end of 'extern "C"'
#endif

/* Directory path separator; Unix uses '/', DOS uses '\'. */
/* Rumor has it that the Mac uses ':'.                    */
#define DIRSEPCHAR '\\'
#define DIRSEPSTR  "\\"
#define PATHSPLITSTR ";"

#endif /* OOMMFPORT_H */
